﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;

namespace VoteApp.Models
{
    public class Vote
    {
        public int VoteSystemId { get; set; }
        public string VoteSystemName { get; set; }
        public int VoteId { get; set; }
        public string VoteName { get; set; }
        public int Score { get; set; }
        public string Comment { get; set; }

        public List<Vote> GetVoteResults(string connectionString)
        {

            List<Vote> voteResults = new List<Vote>();

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select VoteSystemId, VoteSystemName, AVG(Score) AS AverageScore from VoteSystemData group by VoteSystemName, VoteSystemId order by AverageScore desc";

            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    Vote vote = new Vote();

                    vote.VoteSystemId = Convert.ToInt32(dr["VoteSystemId"]);
                    vote.VoteSystemName = dr["VoteSystemName"].ToString();
                    vote.Score = Convert.ToInt32(dr["AverageScore"]);


                    voteResults.Add(vote);
                }

            }

            return voteResults;
        }


        public List<Vote> GetMyVotes(string connectionString, string userName)
        {

            List<Vote> voteResults = new List<Vote>();

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select VoteSystemId, VoteSystemName, Score, Comment from VoteSystemData where VoteName='" + userName + "' order by VoteSystemName";

            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    Vote vote = new Vote();

                    vote.VoteSystemId = Convert.ToInt32(dr["VoteSystemId"]);
                    vote.VoteSystemName = dr["VoteSystemName"].ToString();
                    vote.Score = Convert.ToInt32(dr["Score"]);
                    vote.Comment = dr["Comment"].ToString();


                    voteResults.Add(vote);
                }

            }

            return voteResults;
        }


        public List<Vote> ChartVoteResults(string connectionString)
        {

            List<Vote> voteResults = new List<Vote>();

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select VoteSystemName, AVG(Score) AS AverageScore from VoteSystemData group by VoteSystemName order by VoteSystemName";

            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    Vote vote = new Vote();

                    vote.VoteSystemName = dr["VoteSystemName"].ToString();
                    vote.Score = Convert.ToInt32(dr["AverageScore"]);


                    voteResults.Add(vote);
                }

            }

            return voteResults;
        }


        public List<Vote> ChartSelection(string connectionString, int voteSystemId)
        {

            List<Vote> voteResults = new List<Vote>();

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select VoteName, Score from VoteSystemData where VoteSystemId=" + voteSystemId + " order by VoteName";

            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    Vote vote = new Vote();

                    vote.VoteName = dr["VoteName"].ToString();
                    vote.Score = Convert.ToInt32(dr["Score"]);


                    voteResults.Add(vote);
                }

            }

            return voteResults;
        }


        public List<Vote> VoteDetails(string connectionString, int voteSystemId)
        {

            List<Vote> voteDetails = new List<Vote>();

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select VoteId, VoteName, Score, Comment from VOTE where VoteSystemId=" + voteSystemId + " order by VoteName";

            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    Vote vote = new Vote();

                    vote.VoteId = Convert.ToInt32(dr["VoteId"]);
                    vote.VoteName = dr["VoteName"].ToString();
                    vote.Score = Convert.ToInt32(dr["Score"]);
                    vote.Comment = dr["Comment"].ToString();

                    voteDetails.Add(vote);
                }

            }

            return voteDetails;
        }


        public void NewVote(string connectionString, Vote vote)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("NewVote", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@VoteSystemId", vote.VoteSystemId));
                    cmd.Parameters.Add(new SqlParameter("@VoteName", vote.VoteName));
                    cmd.Parameters.Add(new SqlParameter("@Score", vote.Score));
                    cmd.Parameters.Add(new SqlParameter("@Comment", vote.Comment));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }

        }


        public void DeleteVotes(string connectionString)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("DeleteVotes", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }

        }



    }

}
