using System;
using System.Collections.Generic;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc.RazorPages;
using VoteApp.Models;

namespace VoteApp.Pages
{
    public class ChartSelectionModel : PageModel
    {
        public List<Vote> chartDataList = new List<Vote>();

        public List<VoteSystem> voteSystems = new List<VoteSystem>();

        string connectionString;

        readonly IConfiguration _configuration;

        public int voteSystemId = 0;

        public ChartSelectionModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        public void OnGet()
        {
            voteSystems = GetSystemList();
        }


        public void OnPost()
        {
            voteSystemId = Convert.ToInt32(Request.Form["VoteSystem"]);

            voteSystems = GetSystemList();

            chartDataList = ChartData();
        }


        private List<VoteSystem> GetSystemList()
        {
            connectionString = _configuration.GetConnectionString("ConnectionString");

            List<VoteSystem> systemList = new List<VoteSystem>();

            VoteSystem voteSystem = new VoteSystem();

            systemList = voteSystem.SystemList(connectionString);

            return systemList;
        }


        private List<Vote> ChartData()
        {
            connectionString = _configuration.GetConnectionString("ConnectionString");

            List<Vote> chartDataList = new List<Vote>();

            Vote chartData = new Vote();

            chartDataList = chartData.ChartSelection(connectionString, voteSystemId);

            return chartDataList;
        }
    }
}
