using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Mvc.RazorPages;
using VoteApp.Models;

namespace VoteApp.Pages
{
    public class EditSystemModel : PageModel
    {
        readonly IConfiguration _configuration;

        public VoteSystem voteSystemDB = new VoteSystem();

        private string connectionString;

        public int login = 0;
        public const string SessionKeyLogin = "_Login";
        public string SessionInfo_Login { get; private set; }

        public int systemId;

        public EditSystemModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }
        public void OnGet()
        {
            GetSessionData();

            SystemData();
        }

        public void OnPost()
        {
            GetSessionData();

            SaveSystemData();
        }


        void GetSessionData()
        {
            if (!string.IsNullOrEmpty(HttpContext.Session.GetString(SessionKeyLogin)))
                login = (int)HttpContext.Session.GetInt32(SessionKeyLogin);
        }


        void SystemData()
        {
            systemId = Convert.ToInt16(Request.Query["systemid"]);

            VoteSystem voteSystem = new VoteSystem();

            connectionString = _configuration.GetConnectionString("ConnectionString");

            voteSystemDB = voteSystem.GetSystemData(connectionString, systemId);
        }


        void SaveSystemData()
        {
            if (login == 2)
            {
                VoteSystem voteSystem = new VoteSystem();

                voteSystem.SystemId = Convert.ToInt16(Request.Form["SystemId"]);
                voteSystem.SystemName = Request.Form["SystemName"];

                connectionString = _configuration.GetConnectionString("ConnectionString");

                voteSystem.EditSystem(connectionString, voteSystem);

                Response.Redirect("./ConfigureSystems");
            }
            else
                Response.Redirect("./Error");
        }

    }
}
