using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Mvc.RazorPages;
using VoteApp.Models;

namespace VoteApp.Pages
{
    public class NewVoteModel : PageModel
    {
        readonly IConfiguration _configuration;

        public int login = 0;
        public string loginName = "";
        public const string SessionKeyLogin = "_Login";
        public string SessionInfo_Login { get; private set; }
        public const string SessionKeyLoginName = "_LoginName";
        public string SessionInfo_LoginName { get; private set; }

        private string connectionString;

        public List<VoteSystem> voteSystems = new List<VoteSystem>();

        public NewVoteModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        public void OnGet()
        {

            VerifyLogin();

            GetSessionData();

            voteSystems = GetSystemList();
        }

        public void OnPost()
        {
            GetSessionData();

            SaveVote();
        }

        void GetSessionData()
        {
            if (!string.IsNullOrEmpty(HttpContext.Session.GetString(SessionKeyLogin)))
                login = (int)HttpContext.Session.GetInt32(SessionKeyLogin);

            if (!string.IsNullOrEmpty(HttpContext.Session.GetString(SessionKeyLoginName)))
                loginName = (string)HttpContext.Session.GetString(SessionKeyLoginName);
        }


        private void VerifyLogin()
        {
            if (!string.IsNullOrEmpty(HttpContext.Session.GetString(SessionKeyLogin)))
                login = (int)HttpContext.Session.GetInt32(SessionKeyLogin);

            if (login != 1)
                Response.Redirect("./ErrorLogin");
        }


        private List<VoteSystem> GetSystemList()
        {
            connectionString = _configuration.GetConnectionString("ConnectionString");

            List<VoteSystem> systemList = new List<VoteSystem>();

            VoteSystem voteSystem = new VoteSystem();

            systemList = voteSystem.SystemList(connectionString);

            return systemList;
        }

        void SaveVote()
        {
            if (login==1)
            { 
                Vote vote = new Vote();

                vote.VoteSystemId = Convert.ToInt32(Request.Form["VoteSystemId"]);
                vote.VoteName = loginName;
                vote.Score = Convert.ToInt32(Request.Form["Score"]);
                vote.Comment = Request.Form["Comment"];

                connectionString = _configuration.GetConnectionString("ConnectionString");

                vote.NewVote(connectionString, vote);

                Response.Redirect("./Systems");

            }
            else
                Response.Redirect("./Error");

        }


    }
}
